#include "stdafx.h"
#include "canurl.h"
#include "canurlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

class CAboutDlg : public CDialog {
public:
    CAboutDlg();
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);
    //}}AFX_VIRTUAL
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD) {
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX) {
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
    // bZ[W nh܂B
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

CCanurlDlg::CCanurlDlg(CWnd* pParent) : CDialog(CCanurlDlg::IDD, pParent) {
    //{{AFX_DATA_INIT(CCanurlDlg)
    m_strAfter = _T("");
    m_strBefore = _T("");
    //}}AFX_DATA_INIT
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCanurlDlg::DoDataExchange(CDataExchange* pDX) {
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CCanurlDlg)
    DDX_Text(pDX, IDC_EDIT_AFTER, m_strAfter);
    DDV_MaxChars(pDX, m_strAfter, 512);
    DDX_Text(pDX, IDC_EDIT_BEFORE, m_strBefore);
    DDV_MaxChars(pDX, m_strBefore, 512);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCanurlDlg, CDialog)
    //{{AFX_MSG_MAP(CCanurlDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_BN_CLICKED(IDC_BTN_CLEAR, OnBtnClear)
    ON_BN_CLICKED(IDC_BTN_TRANS, OnBtnTrans)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CCanurlDlg::OnInitDialog() {
    CDialog::OnInitDialog();
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);
    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL) {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty()) {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
        }
    }
    SetIcon(m_hIcon, TRUE);
    SetIcon(m_hIcon, FALSE);

    return TRUE;
}

void CCanurlDlg::OnSysCommand(UINT nID, LPARAM lParam) {
    if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    } else {
        CDialog::OnSysCommand(nID, lParam);
    }
}

void CCanurlDlg::OnPaint() {
    if (IsIconic()) {
        CPaintDC dc(this);
        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;
        dc.DrawIcon(x, y, m_hIcon);
    } else {
        CDialog::OnPaint();
    }
}

HCURSOR CCanurlDlg::OnQueryDragIcon() {
    return (HCURSOR) m_hIcon;
}

void CCanurlDlg::OnBtnClear() {
    m_strAfter = _T("");
    m_strBefore = _T("");
    UpdateData(FALSE);
}

void CCanurlDlg::OnBtnTrans() {
    DWORD nLen = -1;
    TCHAR cDummy;
    UpdateData(TRUE);
    // get length
    BOOL bRet = ::InternetCanonicalizeUrl(m_strBefore, &cDummy, &nLen, 0);
#if 0  // return test
    if (!bRet) {
        CString str;
        switch (::GetLastError()) {
        case ERROR_BAD_PATHNAME:
            str = _T("Bad Pathname");
            break;
        case ERROR_INSUFFICIENT_BUFFER:
            str = _T("Insufficient Buffer");
            break;
        case ERROR_INTERNET_INVALID_URL:
            str = _T("Invalid URL");
            break;
        case ERROR_INVALID_PARAMETER:
            str = _T("Invalid Parameter");
            break;
        default:
            str = _T("Unknown Error");
            break;
        }
        ::AfxMessageBox(str);
    }
#endif
    if (nLen > 0) {
        try {
            LPTSTR szBuf = new TCHAR[nLen];
            // translate
            bRet = ::InternetCanonicalizeUrl(m_strBefore, szBuf, &nLen, 0);
            if (bRet) {
                m_strAfter = szBuf;
            } else {
            }
            delete[] szBuf;
        } catch (CMemoryException* e) {
            e->Delete();
            ::AfxMessageBox(_T("Memory Exception !"));
        }
        UpdateData(FALSE);
    }
}
